﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;
using System.Data;
using Infragistics.Web.UI;
using Infragistics.WebUI.WebDataInput;

public partial class _Default : System.Web.UI.Page
{
    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        CustomItemTemplate1 _CustomItemTemplate = new CustomItemTemplate1();
        Infragistics.Web.UI.ItemTemplate _ItemTemplate = new Infragistics.Web.UI.ItemTemplate();
        _ItemTemplate.Template = _CustomItemTemplate;
        _ItemTemplate.TemplateID = "CustomItemTemplate";
        this.WebHierarchicalDataGrid1.Templates.Add(_ItemTemplate);

    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (IsPostBack)
        {
            if (Session["hasRowIslands"] != null)
            {
                for (int i = 0; i < WebHierarchicalDataGrid1.GridView.Rows.Count; i++) 
                {
                    if (WebHierarchicalDataGrid1.GridView.Rows[i].RowIslands.Count > 0)
                    {
                        TemplateDataField templateColumn1 = (TemplateDataField)WebHierarchicalDataGrid1.GridView.Rows[i].RowIslands[0].Rows[0].Items[0].Column;
                        templateColumn1.ItemTemplate = new CustomItemTemplate1();
                    }
                }
              //  TemplateDataField templateColumn1 = (TemplateDataField)WebHierarchicalDataGrid1.Bands[0].Columns["Button"];
              //  templateColumn1.ItemTemplate = new CustomItemTemplate1();
            }
        }
    }

    protected void WebHierarchicalDataGrid1_RowIslandsPopulating(object sender, Infragistics.Web.UI.GridControls.ContainerRowCancelEventArgs e)
    {
        e.Cancel = true;
        if(Session["hasRowIslands"] == null)
        {
            Session["hasRowIslands"] = true;
        }
        if (!e.Row.Expanded)
        {
            ContainerGrid child = new ContainerGrid();
            child.Enabled = true;
            child.Level = 1;
            child.AutoGenerateColumns = false;

            TemplateDataField tf = new TemplateDataField();
            tf.Key = "Button";
            tf.ItemTemplate = new CustomItemTemplate1();
            tf.Header.Text = "Button";
            child.Columns.Add(tf);

            e.Row.RowIslands.Add(child);


            RowSelectors selectorBehavior = child.Behaviors.CreateBehavior<RowSelectors>();
            selectorBehavior.RowNumbering = true;


            child.DataSourceID = SqlDataSource2.ID;
            child.DataBind();
        }

        


    }

    protected DataTable populateGrid()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Name");
        DataRow row;
        for (int i = 0; i < 10; i++)
        {
            row = dt.NewRow();
            row.SetField<string>("Name", "Name" + i);
            dt.Rows.Add(row);
        }

        return dt;
    }

}

public class CustomItemTemplate : ITemplate
{
    #region ITemplate Members

    public void InstantiateIn(Control container)
    {

        WebImageButton Btn = new WebImageButton();
        Btn.Text = "MyTmpBtn";

        Btn.Click += new ClickHandler(Btn_Click);
        container.Controls.Add(Btn);
    }

    void Btn_Click(object sender, ButtonEventArgs e)
    {
        throw new NotImplementedException();
    }

    #endregion
}
public class CustomItemTemplate1 : ITemplate
{
    #region ITemplate Members

    public void InstantiateIn(Control container)
    {

        Button Btn = new Button();
        Btn.Text = "MyTmpBtn";

        Btn.Click += new EventHandler(Btn_Click);
        container.Controls.Add(Btn);
    }

    void Btn_Click(object sender, EventArgs e)
    {
        throw new NotImplementedException();
    }

   

    #endregion
}